<script lang="ts">
  import { send, receive } from "./propertyCardCrossfade";

  export let card: PropertyCard;
  export let facedown: boolean = false;

  function getPropertyEmoji(card: PropertyCard): string {
    switch (card) {
      case 1:
        return "🕳️";
      case 2:
        return "📰";
      case 3:
        return "📦";
      case 4:
        return "⛱️";
      case 5:
        return "🏖️";
      case 6:
      case 7:
        return "⛺";
      case 8:
        return "🏕️";
      case 9:
        return "🛖";
      case 10:
        return "🚐";
      case 11:
        return "🛥️";
      case 12:
      case 13:
      case 14:
        return "🏚️";
      case 15:
      case 16:
      case 17:
      case 18:
        return "🏠";
      case 19:
      case 20:
      case 21:
      case 22:
        return "🏡";
      case 23:
      case 24:
      case 25:
        return "🏘️";
      case 26:
        return "🏢";
      case 27:
        return "🏨";
      case 28:
        return "🏰";
      case 29:
        return "🏦";
      case 30:
        return "🛰️";
      default:
        return "";
    }
  }
</script>

<div
  class="outer border shadow"
  class:facedown
  in:receive={{ key: card }}
  out:send={{ key: card }}
>
  {#if facedown}
    <div class="inner">
      <div class="art emoji">🏠</div>
    </div>
  {:else}
    {card}

    <div class="inner">
      <div class="art emoji">{getPropertyEmoji(card)}</div>
    </div>
  {/if}
</div>

<style>
  .outer {
    position: relative;
    font-family: "Delius", cursive;
    font-weight: bold;
    width: 5em;
    height: 7em;
    background: radial-gradient(
      circle at center,
      hsl(30deg 100% 99%),
      hsl(30deg 100% 94%)
    );
    padding: 0.5em;
    color: rgb(236, 0, 0);
    -webkit-text-stroke: 0.03em rgba(0, 0, 0, 0.5);
    text-shadow: 0.05em 0.05em 0.05em rgba(0, 0, 0, 0.5);
  }

  .outer.facedown {
    background: radial-gradient(
      circle at center,
      hsl(96deg 54% 70%),
      hsl(96deg 54% 55%)
    );
  }
  .inner {
    position: absolute;
    top: 0.33em;
    left: 0.33em;
    right: 0.33em;
    bottom: 0.33em;
    border-radius: 0.2em;
  }

  .art {
    font-size: 2.2em;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
  :not(.facedown) .art {
    filter: drop-shadow(0 0 2px #0008);
  }
  .facedown .art {
    filter: sepia(100%) hue-rotate(50deg) saturate(125%) opacity(75%)
      brightness(90%);
  }
</style>
